#define F_CPU 16000000UL
#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */


#define RQ_SET_LED    0
#define RQ_GET_SWITCH 1
#define RQ_GET_LIGHT 2
#define RQ_GET_SOUND 3

uint16_t read_adc(uint8_t channel)// LDR
{
    ADMUX = 0b01000000; 
    ADMUX |= channel;  
    ADCSRA = 0b11000110;
    while ((ADCSRA & (1<<ADSC))) 
        ;
    return ADCL + ADCH*256;  
}

/* ------------------------------------------------------------------------- */
void sv(uint16_t c) //7 Segment
{
	if(c==1)
        	PORTD = 0b00000001;  
		else if(c==2)
			PORTD = 0b00000010;
		else if(c==3)
			PORTD = 0b00000011;
		else if(c==4)
			PORTD = 0b00100000;
		else if(c==5)
			PORTD = 0b00100001;
		else if(c==6)
			PORTD = 0b00100010;
		else if(c==7)
			PORTD = 0b00100011;
		else if(c==8)
			PORTD = 0b01000000;
		else if(c==9)
			PORTD = 0b01000001;
		else if(c==0)
			PORTD = 0b00000000;

}
uint16_t cs() //check sound
{
	ADMUX = 0b01000000;
	ADMUX |= PC4;
	ADCSRA = 0b11000110;
	while((ADCSRA & (1<<ADSC)));
	if(ADCL + ADCH*256>700)
		return 1;
	else
		return 0;
}
uint16_t sw1()  //Swtich
{
	if(!(PINC & (1<<PC0)))
		return 1;
	else
		return 0;
}
uint16_t sw2()
{
	if(!(PINC & (1<<PC1)))
		return 1;
	else
		return 0;
}
uint16_t sw3()
{
	if(!(PINC & (1<<PC2)))
		return 1;
	else
		return 0;
}
uint16_t sw4()
{
	if(!(PINC & (1<<PC3)))
		return 1;
	else
		return 0;
}
int main(void)
{

   /* main event loop */
    //usbInit();

    /* enforce re-enumeration, do this while interrupts are disabled! */
    //usbDeviceDisconnect();
    //_delay_ms(300);
    //usbDeviceConnect();

    /* enable global interrupts */
    //sei();

    /* main event loop */
    uint16_t c=0,ns=0,PW=3,count=0,x[3]={0,1,2};
	PORTB = 0b00000000;
	DDRB  = 0b01111111;
	DDRC  = 0;
    PORTC = (1 << PC0)|(1 << PC1)|(1 << PC2)|(1 << PC3);
	
	
	while(1)
    {	

		//usbPoll();
		while(sw1())
		{	
			DDRD  = 0b01100011;
	    	PORTD = 0b00000000;
			PORTB = 0b00100000;
			while((PINC & (1<<PC2)))
			{
				ADMUX = 0b01000000;
				ADMUX |= PC4;
				ADCSRA = 0b11000110;
				while((ADCSRA & (1<<ADSC)));
				_delay_ms(400);
				if(ADCL + ADCH*256>700)
					ns+=1;
				if(ns==10)
					ns=0;
				sv(ns);
			}
			if(ns==PW)
			{
				PORTB = 0b00000000;
				DDRD  = 0b01100011;
	    			PORTD = 0b00000000;
				while(1)
				{
					//usbPoll();
					c=read_adc(5)/100;
					sv(c);
					_delay_ms(400);
					if(sw2()==1)
					{		
						if(count==0)
						{
							if(c==x[0]&&sw2()==1)
							{
								count++;
								PORTB=0b00000010;
								_delay_ms(700);
							
							}
							else
							{
								count=0;
								PORTB=0b00000000;
							}
						}
						else if(count==1)
						{
							if(c==x[1]&&sw2()==1)
							{
								count++;
								PORTB=0b00000110;
								_delay_ms(700);
								
							}
							else
							{
								count=0;
								PORTB=0b00000000;
							}
						}
						else if(count==2)
						{
							if(c==x[2]&&sw2()==1)
							{
								count++;
								PORTB=0b00001110;
								_delay_ms(700);
								PORTB=0b00000001;
								DDRD  = 0b00000000;
							}
							else
							{
								count=0;
								PORTB=0b00000000;
							}
						}
					}
					else if(sw4()==1)
					{
						count=0;
						PORTB=0b00100000;
						while(1)
						{
							c=read_adc(5)/100;
							sv(c);
							_delay_ms(400);
							PORTB|=0b00100000;
							if(sw2()==1)	
							{
								if(count==0)
								{
									x[0]=c;
									count+=1;
									PORTB|=0b00100010;
									_delay_ms(700);
								}
								else if(count==1)
								{
									x[1]=c;
									count+=1;
									PORTB|=0b00100110;
									_delay_ms(700);
								}	
								else if(count==2)
								{
									x[2]=c;
									count=0;
									PORTB|=0b00101110;
									_delay_ms(700);
									PORTB=0b00000000;
									break;
								}		
							}						
						}
					}						
					
				}
			}
			//else
				ns=0;
		}DDRD  = 0b00000000;
    }
    return 0;
}

/* ------------------------------------------------------------------------- */
